"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _rx = require("rx");

var _rx2 = _interopRequireDefault(_rx);

var _socket = require("socket.io-client");

var _socket2 = _interopRequireDefault(_socket);

var _uuid = require("uuid");

var _uuid2 = _interopRequireDefault(_uuid);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let FalcorWebSocketDataSource = class FalcorWebSocketDataSource {

	constructor(url, config) {
		let event = arguments.length <= 2 || arguments[2] === undefined ? "falcor" : arguments[2];

		this.socket = new _socket2.default(url, config);
		this.event = event;
	}

	call(functionPath, args, refSuffixes, thisPaths) {
		return this.subscribe("call", { args, functionPath, refSuffixes, thisPaths });
	}

	get(pathSets) {
		return this.subscribe("get", { pathSets });
	}

	set(jsonGraphEnvelope) {
		return this.subscribe("set", { jsonGraphEnvelope });
	}

	subscribe(method, parameters) {
		const id = (0, _uuid2.default)();
		this.socket.emit(this.event, (0, _extends3.default)({ id, method }, parameters));
		return _rx2.default.Observable.create(observer => {
			this.socket.on(this.event, data => {
				if (data.id === id) {
					observer.onNext(data);
					observer.onCompleted();
				}
			});
		});
	}

};
exports.default = FalcorWebSocketDataSource;